# copyright Howard Wu and Tsong-Min Wu (2017.4)
#
import urllib.request
import sys
import os
from subprocess import call

file_names = []

def getPdf(book_number, start, end, count):
    if (start > end):
        return
    elif (start + 49 > end):
        url = "http://dl.ndl.go.jp/view/pdf/digidepo_{0}.pdf?pdfOutputRanges={1}-{2}&pdfOutputRangeType=R&pdfPageSize=".format(book_number, start, end)
        file_name = '{0}_{1}.pdf'.format(book_number, count)
        file_names.append(file_name)
        urllib.request.urlretrieve(url, file_name)
        return
    else:
        url = "http://dl.ndl.go.jp/view/pdf/digidepo_{0}.pdf?pdfOutputRanges={1}-{2}&pdfOutputRangeType=R&pdfPageSize=".format(book_number, start, start+49)
        file_name = '{0}_{1}.pdf'.format(book_number, count)
        file_names.append(file_name)
        urllib.request.urlretrieve(url, file_name)
        return getPdf(book_number, start + 50, end, count+1)
#
# usage: pypy run.py (書籍編號) (書名) (開始頁碼) (結束頁碼)
#

if (len(sys.argv) != 5 or int(sys.argv[3]) > int(sys.argv[4])):
    print('usage: pypy fetch.py [book number] [book name] [start page] [end page]')
else:
    book_number = sys.argv[1]
    book_name = sys.argv[2]
    start = sys.argv[3]
    end = sys.argv[4]
    getPdf(book_number, int(start), int(end), 1)

    call(["gswin64c.exe", "-dBATCH", "-dNOPAUSE", "-q","-dBATCH", "-sPAPERSIZE=a4", "-dCompatibilityLevel=1.5", \
        "-sDEVICE=pdfwrite", "-sOutputFile=booktitle.pd"] + file_names)

#     call(["mgs", "-dBATCH", "-dNOPAUSE", "-q","-dBATCH", "-sPAPERSIZE=a4", "-dCompatibilityLevel=1.5", \
#         "-sDEVICE=pdfwrite", "-sOutputFile=booktitle.pdf"] + file_names)
#    os.rename("merged.pdf", book_name + ".pdf")


